/*
 * msrtest.C
 */

#include	<basic.h>
#include	<bstdio.h>
#include	<bstdlib.h>
#include	<errcode.h>
#include	<btron/btron.h>


EXPORT	ERR	main()
{
    WERR	err;
    W	dd, error, size;
    TC	devname[] = {L""};
    UW	i, buf[3];

    /* open */
    err = opn_dev(devname, D_UPDATE | D_EXCL, &error);
    if(err < 0) {
	printf("opn_dev(): %d\n", err);
	goto fin;
    }
    dd = (W)err;

    /* read & dump */
    for(i = 0x200; i < 0x210; i++) {
	buf[0] = i;
	err = rea_dev(dd, 0, (VP)buf, sizeof(buf), &size, &error);

	if(err < 0) printf("rea_dev(): %d\n", err);
	if(size != sizeof(buf)) printf("size mismatch: %d\n", size);

	printf("%08x: %08x%08x\n", i, buf[2], buf[1]);
    }

    /*	close	*/
    err = cls_dev(dd, 0, &error);
    if(err < 0) {
	printf("cls_dev(): %d\n", err);
	goto fin;
    }

    err = ER_OK;
 fin:
    return err;
}
